/**
 * Can't think of a better name for this right now but...
 * A Topic Setter is a layer between producing a message that sets some data, but ignores the update if there is no change.
 * First it consumes all messages in the topic and stores them by logCompactId
 * Then when we want to set the same id to the same payload value, it ignores it to prevent unnecessary messages.
 * This class is very useful in a processor that outputs to a log compacted topic.
 */
import { TopicConsumer } from "./topicConsumer";
import { TopicProducer } from "./topicProducer";
export default class TopicSetter<T> {
    private consumer;
    private producer;
    private memoryHash;
    private isReady;
    private messagesToApply;
    private messagesToPush;
    private isProducingMessages;
    private lastTriggered;
    constructor(consumer: TopicConsumer<T>, producer: TopicProducer<T>);
    start(): Promise<void>;
    /**
     * Run this after sending bulk messages using autoFlush = false
     */
    triggerWaitingMessages(): Promise<void>;
    private produceWaitingMessages;
    private processMessage;
    setLogCompactedPayload(logCompactId: string, payload: T, autoFlush?: boolean): void;
    setPayload(payload: T, autoFlush?: boolean): void;
}
